#!/bin/bash

#-------------------------------------------------------------
# SCRIPT PARA ALTERAR O TIPO DO FTP 
#   0 - OFF (default)
#   1 - FTP
#   2 - FTPS#
#
# script localizado em: /opt/weg/scripts/ftp/ 
#
# Version: 1.2
#
#------------------------------------------------------------- 


#-------------------------------------------------------
# Pega o type do arquivo .json
#   0 - OFF (default)
#   1 - FTP
#   2 - FTPS
#------------------------------------------------------- 
FTP_TYPE=$(grep -oP '(?<="FTP_TYPE": )[0-9]+' /etc/weg/ftp/ftpcfg.json)

#-------------------------------------------------------
# Altera o arquivo de configuracao dependendo do type escolhido
#------------------------------------------------------- 
case "$FTP_TYPE" in 
    1)
        cp /etc/weg/ftp/vsftpdFTP.conf /etc/vsftpd.conf
            if [ $? -ne 0 ]; then echo "plclogFTP: $0 FAULT $LINENO" | systemd-cat; fi 
        sleep 0.5
        systemctl restart vsftpd
            if [ $? -ne 0 ]; then echo "plclogFTP: $0 FAULT $LINENO" | systemd-cat; fi 
        echo 'FTP Enable'    
        ;;
    2) 
        cp /etc/weg/ftp/vsftpdFTPS.conf /etc/vsftpd.conf
            if [ $? -ne 0 ]; then echo "plclogFTP: $0 FAULT $LINENO" | systemd-cat; fi 
        sleep 0.5
        systemctl restart vsftpd
            if [ $? -ne 0 ]; then echo "plclogFTP: $0 FAULT $LINENO" | systemd-cat; fi 
        echo 'FTPS Enable'
        ;;
    *)
        systemctl stop vsftpd
        echo 'FTP Disable'
        ;;
    esac



                                        

