#!/bin/bash
# plcftpshare.sh
# script localizado em: /opt/weg/scripts/ftp/

#-------------------------------------------------------------
# Carrega as variáveis e funções utilizadas pelos PLCs WEG
#-------------------------------------------------------------
source /opt/weg/scripts/plcDefines.sh

case "$1" in
    "-h" | "--help" | "")
        echo ""
        echo "------------------------------------------------------"
        echo "plcftpshare HELP"
        echo "------------------------------------------------------"
        echo "--usb        : Atualiza a configuração de compartilhamento via FTP da pasta USB conforme /etc/weg/ftp/ftpcfg.json"
        echo "--sdcard     : Atualiza a configuração de compartilhamento via FTP da pasta SDcard conforme /etc/weg/ftp/ftpcfg.json"
        echo "------------------------------------------------------"
        ;;

    "--sdcard")
        #---------------------------------------------------------
        # Read /etc/weg/ftp/ftpcfg.json and create or remove symbolic link
        #---------------------------------------------------------
        if [ -f "/etc/weg/ftp/ftpcfg.json" ]; then
            ftpcfg=$(cat /etc/weg/ftp/ftpcfg.json)
            FTP_SD=$(grep -oP '"FTP_SD": \K\d+' <<< "$ftpcfg")

            if [ "$FTP_SD" == "1" ]; then 
                if [ -d "/mnt/sdcard" ]; then
                    if [ ! -d "/home/wegftp/ftp/files/SDcard" ]; then mkdir -p /home/wegftp/ftp/files/SDcard; fi
                    if [ ! -d "/var/lib/weg/codesys/ftp/SDcard" ]; then mkdir -p /var/lib/weg/codesys/ftp/SDcard; fi
                    if ! mountpoint -q /home/wegftp/ftp/files/SDcard; then mount --bind /mnt/sdcard /home/wegftp/ftp/files/SDcard; fi
                    if ! mountpoint -q /var/lib/weg/codesys/ftp/SDcard; then mount --bind /mnt/sdcard /var/lib/weg/codesys/ftp/SDcard; fi
                fi
            elif [ "$FTP_SD" == "0" ]; then 
                if mountpoint -q /var/lib/weg/codesys/ftp/SDcard; then
                    /usr/bin/umount -f /var/lib/weg/codesys/ftp/SDcard
                    /usr/bin/umount -f -l /var/lib/weg/codesys/ftp/SDcard
                    if ! mountpoint -q /var/lib/weg/codesys/ftp/SDcard; then
                        /usr/bin/rm -rf /var/lib/weg/codesys/ftp/SDcard
                    else
                        plcLog WARN FTP SDcard folder could NOT be removed in configuration
                    fi
                fi
                if mountpoint -q /home/wegftp/ftp/files/SDcard; then
                    /usr/bin/umount -f /home/wegftp/ftp/files/SDcard
                    /usr/bin/umount -f -l /home/wegftp/ftp/files/SDcard
                    if ! mountpoint -q /home/wegftp/ftp/files/SDcard; then
                        /usr/bin/rm -rf /home/wegftp/ftp/files/SDcard
                    else
                        plcLog WARN FTP SDcard folder could NOT be removed in configuration
                    fi
                fi
            fi
            /opt/weg/scripts/plcaddsd.sh
        fi
        ;;

    "--usb")
        #---------------------------------------------------------
        # Read /etc/weg/ftp/ftpcfg.json and create or remove symbolic link
        #---------------------------------------------------------
        if [ -f "/etc/weg/ftp/ftpcfg.json" ]; then
            ftpcfg=$(cat /etc/weg/ftp/ftpcfg.json)
            FTP_USB=$(grep -oP '"FTP_USB": \K\d+' <<< "$ftpcfg")

            if [ "$FTP_USB" == "1" ]; then 
                if [ -d "/mnt/usb" ]; then
                    if [ ! -d "/home/wegftp/ftp/files/USB" ]; then mkdir -p /home/wegftp/ftp/files/USB; fi
                    if [ ! -d "/var/lib/weg/codesys/ftp/USB" ]; then mkdir -p /var/lib/weg/codesys/ftp/USB; fi
                    if ! mountpoint -q /home/wegftp/ftp/files/USB; then mount --bind /mnt/usb /home/wegftp/ftp/files/USB; fi
                    if ! mountpoint -q /var/lib/weg/codesys/ftp/USB; then mount --bind /mnt/usb /var/lib/weg/codesys/ftp/USB; fi
                fi
            elif [ "$FTP_USB" == "0" ]; then 
                if mountpoint -q /var/lib/weg/codesys/ftp/USB; then
                    /usr/bin/umount -f /var/lib/weg/codesys/ftp/USB
                    /usr/bin/umount -f -l /var/lib/weg/codesys/ftp/USB
                    if ! mountpoint -q /var/lib/weg/codesys/ftp/USB; then
                        /usr/bin/rm -rf /var/lib/weg/codesys/ftp/USB
                    else
                        plcLog WARN FTP USB folder could NOT be removed in configuration
                    fi
                fi
                if mountpoint -q /home/wegftp/ftp/files/USB; then
                    /usr/bin/umount -f /home/wegftp/ftp/files/USB
                    /usr/bin/umount -f -l /home/wegftp/ftp/files/USB
                    if ! mountpoint -q /home/wegftp/ftp/files/USB; then
                        /usr/bin/rm -rf /home/wegftp/ftp/files/USB
                    else
                        plcLog WARN FTP USB folder could NOT be removed in configuration
                    fi
                fi
            fi
            /opt/weg/scripts/plcaddusb.sh
        fi
        ;;

    *)
        echo "No option provided or invalid option. Try -h to see the help."
        ;;
esac
