#!/bin/bash

#-------------------------------------------------------------
# ENCRYPT SIMPLE LOG FILES
#
# September/2023
# 
#-------------------------------------------------------------


#-------------------------------------------------------------
# Carrega as variáveis e funções utilizadas pelos PLCs WEG
#-------------------------------------------------------------
source /opt/weg/scripts/plcDefines.sh


#-------------------------------------------------------------
# Trap to catch line errors
#-------------------------------------------------------------
trap 'plcLog ERROR Trap!' ERR


#-------------------------------------------------------------
# Cria pasta supportLogs
#-------------------------------------------------------------
mkdir -p /var/lib/weg/codesys/supportLogs


#-------------------------------------------------------------
# Comprime a pasta de logs
#-------------------------------------------------------------
cd /var/log/ && tar -cvf ~/plcLogs.tar weg


#-------------------------------------------------------------
# Cria a senha para os logs
#-------------------------------------------------------------
senha="JARAGUA987654321"


#-------------------------------------------------------------
# Exporta a senha como variável de ambiente
#-------------------------------------------------------------
export GPG_PASSPHRASE="$senha"


#-------------------------------------------------------------
# Encripta o arquivo com a senha
#-------------------------------------------------------------
gpg --batch --yes --passphrase "$GPG_PASSPHRASE" -c ~/plcLogs.tar && rm ~/plcLogs.tar 


#-------------------------------------------------------------
# Move o arquivo de log para a pasta supportLogs
#-------------------------------------------------------------
cd && mv plcLogs.tar.gpg /var/lib/weg/codesys/supportLogs


#-------------------------------------------------------------
# Limpa a variável de ambiente
#-------------------------------------------------------------
unset GPG_PASSPHRASE


#-------------------------------------------------------------
# Deixa log do tipo WARN
#-------------------------------------------------------------
plcLog WARN PLC Shell used to get support logs
