#!/bin/bash
# plcrmsd.sh
# script localizado em: /opt/weg/scripts/  

#-------------------------------------------------------------
# Carrega as variáveis e funções utilizadas pelos PLCs WEG
#-------------------------------------------------------------
source /opt/weg/scripts/plcDefines.sh

#---------------------------------------------------------
# Verifica se existe a pasta
#---------------------------------------------------------
if [ -d /mnt/sdcard ]; then

    #---------------------------------------------------------
    # Confere se /dev/mmcblk0p1 e /mnt/sdcard está montada
    #---------------------------------------------------------
    n1=0
    until [ "$n1" -ge 10 ]
    do      

        # Verifica se /mnt/sdcard está montado e tenta desmontar
        if mount | grep mmcblk0p1 > /dev/null; then 
            /usr/bin/umount -f /dev/mmcblk0p1
            /usr/bin/umount -f -l /mnt/sdcard
        fi

        # Verifica se /home/wegftp/ftp/files/SDcard está montado e tenta desmontar
        if [ -d /home/wegftp/ftp/files/SDcard ] && mount | grep '/home/wegftp/ftp/files/SDcard' > /dev/null; then 
            /usr/bin/umount -f /home/wegftp/ftp/files/SDcard
            /usr/bin/umount -f -l /home/wegftp/ftp/files/SDcard
        fi

        # Verifica se /var/lib/weg/codesys/ftp/SDcard está montado e tenta desmontar
        if [ -d /var/lib/weg/codesys/ftp/SDcard ] && mount | grep '/var/lib/weg/codesys/ftp/SDcard' > /dev/null; then 
            /usr/bin/umount -f /var/lib/weg/codesys/ftp/SDcard
            /usr/bin/umount -f -l /var/lib/weg/codesys/ftp/SDcard
        fi

        if [ -d /home/wegftp/ftp/files/SDcard ]; then /usr/bin/rm -rf /home/wegftp/ftp/files/SDcard; fi

        if [ -d /var/lib/weg/codesys/ftp/SDcard ]; then /usr/bin/rm -rf /var/lib/weg/codesys/ftp/SDcard; fi

        # Verifica se ambos os pontos de montagem foram desmontados
        if mount | grep '/mnt/sdcard' > /dev/null || mount | grep '/home/wegftp/ftp/files/SDcard' > /dev/null; then 
            n1=$((n1 + 1))
            sleep 1
        else
            n1=100
        fi

    done

    # Testa mais uma vez se /dev/mmcblk0p1 está montado
    if mount | grep mmcblk0p1 > /dev/null; then plcLog WARN SD card could NOT be umounted; fi
    if mount | grep '/home/wegftp/ftp/files/SDcard' > /dev/null; then plcLog WARN FTP SD card could NOT be umounted; fi

    #---------------------------------------------------------
    # Confere se existe a pasta /mnt/sdcard e tenta remove-la
    #---------------------------------------------------------
    n1=0
    until [ "$n1" -ge 20 ]
    do      

        if [ -d /mnt/sdcard ]; then 
            # Tenta excluir a pasta 
            /usr/bin/rm -rf /mnt/sdcard
        fi

        if [ -d /home/wegftp/ftp/files/SDcard ]; then 
            # Tenta excluir a pasta 
            /usr/bin/rm -rf /home/wegftp/ftp/files/SDcard
        fi

        if [ -d /var/lib/weg/codesys/ftp/SDcard ]; then 
            # Tenta excluir a pasta 
            /usr/bin/rm -rf /var/lib/weg/codesys/ftp/SDcard
        fi

        if [ -d /mnt/sdcard ] && [ -d /home/wegftp/ftp/files/SDcard ] && [ -d /var/lib/weg/codesys/ftp/SDcard ]; then n1=$((n1 + 1)); sleep 1; else n1=100; fi



    done

    # Testa mais uma vez se a pasta /mnt/sdcard foi removida
    if [ -d /mnt/sdcard ]; then plcLog WARN SD card folder could NOT be removed; fi
    if [ -d /home/wegftp/ftp/files/SDcard ]; then plcLog WARN FTP SD card folder could NOT be removed; fi

fi