#!/bin/bash
# plcrmusb.sh
# script localizado em: /opt/weg/scripts/  

#-------------------------------------------------------------
# Carrega as variáveis e funções utilizadas pelos PLCs WEG
#-------------------------------------------------------------
source /opt/weg/scripts/plcDefines.sh


#---------------------------------------------------------
# Verifica se existe a pasta
#---------------------------------------------------------
if [ -d /mnt/usb ]; then

    #---------------------------------------------------------
    # Confere está montada a pasta /mnt/usb e /dev/sd*
    #---------------------------------------------------------
    n1=0
    until [ "$n1" -ge 10 ]
    do      
        # Verifica se /mnt/usb está montado e tenta desmontar
        if mount | grep '/mnt/usb' > /dev/null; then 
            /usr/bin/umount -f /mnt/usb
            /usr/bin/umount -f -l /mnt/usb
        fi

        if [ -d "/home/wegftp/ftp/files/USB" ] && mount | grep '/home/wegftp/ftp/files/USB' > /dev/null; then 
            /usr/bin/umount -f /home/wegftp/ftp/files/USB
            /usr/bin/umount -f -l /home/wegftp/ftp/files/USB
        fi

        # Verifica se /var/lib/weg/codesys/ftp/USB está montado e tenta desmontar
        if [ -d "/var/lib/weg/codesys/ftp/USB" ] && mount | grep '/var/lib/weg/codesys/ftp/USB' > /dev/null; then 
            /usr/bin/umount -f /var/lib/weg/codesys/ftp/USB
            /usr/bin/umount -f -l /var/lib/weg/codesys/ftp/USB
        fi

        # Verifica se ambos os pontos de montagem foram desmontados
        if mount | grep '/mnt/usb' > /dev/null || mount | grep '/var/lib/weg/codesys/ftp/USB' > /dev/null || mount | grep '/home/wegftp/ftp/files/USB' > /dev/null ; then 
            n1=$((n1 + 1))
            sleep 1
        else
            n1=100
        fi
    done

    # Testa mais uma vez se /mnt/usb foi desmontado
    if mount | grep '/mnt/usb' > /dev/null; then plcLog WARN USB folder is STILL mounted; fi
    if mount | grep '/var/lib/weg/codesys/ftp/USB' > /dev/null; then plcLog WARN FTP USB /var/lib/.. folder is STILL mounted; fi
    if mount | grep '/home/wegftp/ftp/files/USB' > /dev/null; then plcLog WARN FTP USB /home/wegftp/.. folder is STILL mounted; fi

    #---------------------------------------------------------
    # Confere se existe a pasta /mnt/usb e tenta remove-la
    #---------------------------------------------------------
    n1=0
    until [ "$n1" -ge 20 ]
    do      

        if [ -d /mnt/usb ]; then 
            # Tenta excluir a pasta 
            /usr/bin/rm -rf /mnt/usb
        fi

        if [ -d "/var/lib/weg/codesys/ftp/USB" ]; then 
            # Tenta excluir a pasta 
            /usr/bin/rm -rf /var/lib/weg/codesys/ftp/USB
        fi

        if [ -d "/home/wegftp/ftp/files/USB" ]; then 
            # Tenta excluir a pasta 
            /usr/bin/rm -rf /home/wegftp/ftp/files/USB
        fi

        if [ -d "/mnt/usb" ] && [ -d "/var/lib/weg/codesys/ftp/USB" ] && [ -d "/home/wegftp/ftp/files/USB" ]; then n1=$((n1 + 1)); sleep 1; else n1=100; fi

    done

    # Testa mais uma vez se a pasta /mnt/usb foi removida
    if [ -d "/mnt/usb" ]; then plcLog WARN USB folder could NOT be removed; fi
    if [ -d "/var/lib/weg/codesys/ftp/USB" ]; then plcLog WARN FTP USB /var/lib/.. folder could NOT be removed; fi
    if [ -d "/home/wegftp/ftp/files/USB" ]; then plcLog WARN FTP USB /home/wegftp/.. folder could NOT be removed; fi
fi