#!/bin/bash

#-------------------------------------------------------------
# Carrega as variáveis e funções utilizadas pelos PLCs WEG
#-------------------------------------------------------------
source /opt/weg/scripts/plcDefines.sh

#-------------------------------------------------------------
# Logs
#-------------------------------------------------------------
HW_VERS=$(grep -oP '(?<="HW_VERSION": )[0-9]+' /etc/weg/firstBoot.json)
FW_VERS=$(dpkg -s firmware-plc500 | grep '^Version:' | sed 's/Version: //');


#-------------------------------------------------------------
# Copy core-app logs to the /var/log/weg/core-app
#-------------------------------------------------------------
if [[ "$HW_VERS" == "3" ]] && [[ -d "/var/log/core-app/" ]]; then
    cp -r var/log/core-app/ /var/log/weg/core-app;
fi

if [[ -d "/var/log/weg/core-app/" ]]; then
    rm -r /var/log/weg/core-app;
fi

[[ -d "/var/log/weg/core-app/" ]] && rm -r /var/log/weg/core-app;

#-------------------------------------------------------------
# Copy Codesys logs to the /var/log/weg/
#-------------------------------------------------------------
if ls /var/lib/weg/codesys/logPLC*.csv 1> /dev/null 2>&1; 
then cp /var/lib/weg/codesys/logPLC*.csv /var/log/weg/; fi


#-------------------------------------------------------------
# Copy journalctl logs to /var/log/weg/
#-------------------------------------------------------------
journalctl > /var/log/weg/journal.log


echo "---------------------------------------------------" > /var/log/weg/plcAll.log;
echo "$HOSTNAME" >> /var/log/weg/plcAll.log;
echo "" >> /var/log/weg/plcAll.log;
echo "$(logtime)" >> /var/log/weg/plcAll.log;
echo "HW  version = $HW_VERS" >> /var/log/weg/plcAll.log;
echo "FW  version = $FW_VERS" >> /var/log/weg/plcAll.log;
printf "DTB version = " >> /var/log/weg/plcAll.log; cat /proc/device-tree/model >> /var/log/weg/plcAll.log;

if [ -f "/etc/weg/plchash.json" ]; then
    echo "hash        = $(cat /etc/weg/plchash.json)" >> /var/log/weg/plcAll.log;
    echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
fi

echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;

echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "lsblk" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
lsblk >> /var/log/weg/plcAll.log; 
echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;


echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "ls /mnt/" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
ls /mnt/ >> /var/log/weg/plcAll.log; 
echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;


echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "lsusb" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
lsusb >> /var/log/weg/plcAll.log; 
echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;


echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "ls /lib/modules" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
ls /lib/modules >> /var/log/weg/plcAll.log; 
echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;


echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "ifconfig" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
ifconfig >> /var/log/weg/plcAll.log; 
echo >> /var/log/weg/plcAll.log;


echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "/etc/network/interfaces.d/" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
ls /etc/network/interfaces.d/ >> /var/log/weg/plcAll.log; 
echo >> /var/log/weg/plcAll.log;
find /etc/network/interfaces.d/ -type f -exec cat {} \; -exec echo ""\; -exec echo ""\; >> /var/log/weg/plcAll.log; 
echo >> /var/log/weg/plcAll.log;


echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "default route (route -n)" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
route -n >> /var/log/weg/plcAll.log; 
echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;


echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "pstree" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
pstree >> /var/log/weg/plcAll.log; 
echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;


echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "lsmod" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
lsmod >> /var/log/weg/plcAll.log; 
echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;


echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "gpios" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
ls /sys/class/gpio/ | pr -4 -T -w 52 >> /var/log/weg/plcAll.log; 
echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;


echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "pwms" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
ls /sys/class/pwm/ >> /var/log/weg/plcAll.log; 
echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;


echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "systemctl list-units --type=service" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
systemctl list-units --type=service >> /var/log/weg/plcAll.log; 
echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;


echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "systemctl status plcinit" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
systemctl status plcinit >> /var/log/weg/plcAll.log; 
echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;


echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "systemctl status plcwebpage" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
if [[ "$HW_VERSION" != "3" ]]; 
then 
    systemctl status plcwebpage >> /var/log/weg/plcAll.log; 
fi
echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;


echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "/dev/" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
ls /dev | pr -12 -T -w 130 >> /var/log/weg/plcAll.log; 
echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;


echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "/proc/interrupts" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
cat /proc/interrupts >> /var/log/weg/plcAll.log; 
echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;


echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "fw_printenv" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
fw_printenv >> /var/log/weg/plcAll.log; 
echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;


echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "dpkg -l" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
dpkg -l | awk 'NR>5 { printf "%-35s %-22s\n", $2, $3 }' >> /var/log/weg/plcAll.log; 
echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;


echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "auth.log" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
if [[ -f "/var/log/auth.log" ]]; 
then
    cat /var/log/auth.log >> /var/log/weg/plcAll.log; 
fi
echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;


echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "cron.log" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
if [[ -f "/var/log/cron.log" ]];
then
    cat /var/log/cron.log >> /var/log/weg/plcAll.log; 
fi
echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;


echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "CODESYSControl.cfg" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
if [[ -f "/etc/weg/codesys/CODESYSControl.cfg" ]];
then
    cat /etc/weg/codesys/CODESYSControl.cfg >> /var/log/weg/plcAll.log; 
fi
echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;

echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
echo "CODESYSControlShell.cfg" >> /var/log/weg/plcAll.log; 
echo "---------------------------------------------------" >> /var/log/weg/plcAll.log;
if [[ -f "/etc/weg/codesys/CODESYSControlShell.cfg" ]];
then
    cat /etc/weg/codesys/CODESYSControlShell.cfg >> /var/log/weg/plcAll.log;
else
    echo "File not found!" >> /var/log/weg/plcAll.log;
fi
echo >> /var/log/weg/plcAll.log;
echo >> /var/log/weg/plcAll.log;

#-------------------------------------------------------------
# Log to plcLogs
#-------------------------------------------------------------
plcLog INFO created log file from the secret script

