function getCookiesMap(cookiesString) {
    return cookiesString.split(";")
        .map(function (cookieString) {
            return cookieString.trim().split("=");
        })
        .reduce(function (acc, curr) {
            acc[curr[0]] = curr[1];
            return acc;
        }, {});
}

var cookies = getCookiesMap(document.cookie);
console.log(cookies);

var PLCMEMORY;

if (cookies["boot"] != 'None') {
    if (cookies["boot"] == 0) {
        window.alert("The PLC application is ready to be updated. The system will reboot now.");
    }
    else if (cookies["boot"] == -2 || cookies["boot"] == -3 || cookies["boot"] == -4) {
        window.alert("Some error has occurred in the application update files!");
    }
    else {
        console.log("Application update error!");
    }
}

if (cookies["update"] != 'None') {
    console.log("Cookies: ", cookies["update"]);
    if (cookies["update"] == 0) {
        window.alert("The PLC firmware is ready to be updated. The system will reboot now.\n\nAt the end of the process, the webpage will return automatically.");
    }
    else if (cookies["update"] == -4) {
        window.alert("The PLC firmware is ready to be updated. The system will reboot now.\n\nAt the end of the process, the webpage will return automatically.");
    }
    else if (cookies["update"] == -1) {
        window.alert("We were unable to find the firmware file. Please provide it and try again.");
    }
    else if (cookies["update"] == -2) {
        window.alert("There are multiple firmware files. Please provide only one firmware file and try again.");
    }
    else if (cookies["update"] == -3) {
        window.alert("It couldn't decrypt the firmware file. Please provide a gpg file provided by WEG.");
    }
    else if (cookies["update"] == -5) {
        window.alert("You have a higher firmware version installed.");
    }
    else if (cookies["update"] == -6) {
        window.alert("The WEG package could not be installed.");
    }
    else if (cookies["update"] == -7) {
        window.alert("It was not possible to count the number of files.");
    }
    else if (cookies["update"] == -8) {
        window.alert("It was not possible to verify the current firmware version.");
    }
    else if (cookies["update"] == -9) {
        window.alert("Incorrect firmware package. Please provide the correct file.");
    }
    else if (cookies["update"] == -12) {
        window.alert("It couldn't move the firmware file to /tmp/firmware.");
    }
    else if (cookies["update"] == -21) {
        window.alert("The setupParameters.txt could not be found.");
    }
    else if (cookies["update"] == -22) {
        window.alert("The dataInfo.json could not be found.");
    }
    else if (cookies["update"] == -32) {
        window.alert("It couldn't remove the gpg file from the firmware folder.");
    }
    else if (cookies["update"] == -33) {
        window.alert("It couldn't rename the firmware file.");
    }
    else if (cookies["update"] == -34) {
        window.alert("The firmware update package is not signed by WEG.");
    }
    else {
        window.alert("Firmware update error.");
        console.log("Firmware update error!");
    }

    document.cookie = "update=None;";
}

var useTimeOut=0;
var conf_files=0;
var TimeOut=75;

function updateProgress() {
    if (useTimeOut == 1) {
        if (conf_files == 1) {
            var cookies_result = getCookiesMap(document.cookie);
            if (cookies_result["update"] != 'None') {
                if (cookies_result["update"] != 0 && cookies_result["update"] != -4) {
                    window.location.replace("/firmwareupdate.html");
                }
            }
            conf_files = 0;
        }
        document.getElementById('progress').innerHTML = TimeOut+'%';
        document.getElementById('progress').style.width = Math.ceil(TimeOut  * 1.92) + 'px';
        TimeOut = TimeOut+1;
        if (TimeOut > 100) {
            useTimeOut = 0;
            TimeOut = 75;
            window.alert("The PLC firmware is ready to be updated. At the end of the process, the webpage will return automatically.\n\nPlease do not power off the device during the firmware update!");
            window.location.replace("/firmwareupdate.html");
        }
    }
}

function readTextFile(data) {
    document.getElementById("FWVERSION").innerHTML = data.FWVERSION;
    PLCMEMORY = data.FLASHUSEDPERC;
};

fetch('./dataInfo.json')
    .then(function (response) {
        return response.json();
    })
    .then(function (data) {
        readTextFile(data);
    })
    .catch(function (err) {
        console.log(err);
    });

var text;

fetch('versions.txt')
    .then(response => response.text())
    .then(data => text = data.split("\n"))
    .then(() => {
        let tbody = document.getElementById('body')
        for (var line = 0; line < text.length; line++) {
            let paragraph = document.createElement('p');
            let textline = text[line];
            const node = document.createTextNode(textline);
            paragraph.appendChild(node);
            tbody.appendChild(paragraph);
        }
    });

const sizeLimitFiles = 100 * 1024 * 1024;    // 100 MB

let forms = document.getElementsByTagName('form');

for (let i = 1; i < forms.length; i++) {
    let formid = document.getElementById(forms[i].id);
    let inputs = formid.getElementsByTagName('input');
    formPost(inputs, i);
}

function formPost(formelem, index) {
    var formself = document.getElementById(forms[index].id);

    let upload = function () {
        var data = new FormData();

        if (forms[index].id == 'bootupdate') {
            var DisplayAlert = "After the boot application download, all previous applications will be deleted and the Codesys will reboot."
        }
        else if (forms[index].id == 'firmwareupdate') {
            var DisplayAlert = "To update the PLC's firmware, a restart of the device is required. Are you sure you want to proceed with the restart?\n\nPlease do not power off the device during the firmware update!"
        }

        for (let i = 0; i < formelem.length; i++) {
            if (formelem[i].type == 'file') {
                if (formelem[i].files.length === 0) {
                    formelem[i].reportValidity();
                    return;
                }
                if (formelem[i].files[0]) {
                    if (formelem[i].files[0].size >= sizeLimitFiles) {
                        console.log(formelem[i].files[0].size);
                        formself.getElementsByClassName("progress")[0].innerHTML = 'File too large';
                        return;
                    }
                }
                data.append(formelem[i].name, formelem[i].files[0]);
            };
            if (formelem[i].type == 'button') {
                let result = window.confirm(DisplayAlert);
                console.log(result);
                var text = "User select restart: " + result;

                if (result == null || result == "") {
                    text = "User cancelled the prompt.";
                    //e.preventDefault();
                    return false;
                }
        
                console.log(text);

                $('#appsubmit').prop('disabled', true);
                $('#submit').prop('disabled', true);
            };
        };



        let request = new XMLHttpRequest();

        let progress = formself.getElementsByClassName("progress")[0];

        formself.getElementsByClassName("progress_outer")[0].style.display = "inline-block";

        progress.style.background = 'rgb(157, 218, 255)';

        if (forms[index].id == 'bootupdate') {
            request.upload.addEventListener('progress', function (e) {
                let progress_width = Math.ceil(e.loaded / e.total * 100);
                progress.style.width = Math.ceil(progress_width  * 1.92) + 'px';
                formself.getElementsByClassName("progress")[0].innerHTML = progress_width + '%';
            }, false);
    
            request.addEventListener("loadend", () => {
                if (request.readyState === 4 && request.status === 200) {
                    window.location.replace("/firmwareupdate.html");
                };
            });
        }
        else if (forms[index].id == 'firmwareupdate') {
            request.upload.addEventListener('progress', function (e) {
                let progress_width = Math.ceil(e.loaded / e.total * 75);
                progress.style.width = Math.ceil(progress_width  * 1.92) + 'px';
                formself.getElementsByClassName("progress")[0].innerHTML = progress_width + '%';
            }, false);
    
            request.addEventListener("loadend", () => {
                useTimeOut=1;
                conf_files=1;
                if (request.readyState === 4 && request.status === 200) {
                    useTimeOut=1;
                    conf_files=1;
                };
            });
        }



        request.open('POST', window.location.href);
        request.send(data);

    }

    for (let i = 0; i < formelem.length; i++) {
        if (formelem[i].type == 'button') {
            formelem[i].addEventListener('click', upload);
        };
    }
}

function fetchData() {
    fetch('./dataInfo.json')
        .then(function (response) {
            return response.json();
        })
        .then(function (data) {
            readTextFile(data);
        })
        .catch(function (err) {
            console.log(err);
        });
}

setInterval(fetchData, 1500);

setInterval(updateProgress, 1000);

function verificarMemoria() {
     if (PLCMEMORY >= 90) {
        alert("Warning! Internal memory usage has exceeded 90%, for your safety, please refrain from updating the device until you free up more space.")
    }
} 
