let cellTitles = ['General Information', 'CPU', 'Networks']
let rowTexts = {
    'HWVERSION': 'Hardware Version',
    'FWVERSION': 'Firmware Version', 'SYSTIME': 'System Time', 'OPERTIME': 'Operation Time',
    'CODEVERSION': 'Codesys Version',
    'FLASHTOTAL' : 'Internal Memory Total', 'FLASHUSED' : 'Memory Usage', 'FLASHUSEDPERC' : 'Memory Usage (%)',
    'RAMTOTAL' : 'RAM Memory Total', 'RAMUSED' : 'RAM Memory Usage', 'RAMUSEDPERC' : 'RAM Memory Usage (%)',
    'SDTOTAL' : 'SD Memory Total', 'SDUSED' : 'SD Memory Usage', 'SDUSEDPERC' : 'SD Memory Usage (%)',
    'USBTOTAL' : 'USB Memory Total', 'USBUSED' : 'USB Memory Usage', 'USBUSEDPERC' : 'USB Memory Usage (%)',
    'CPULOAD': 'CPU Load (%)', 'TEMPERATURE': 'CPU Temperature (<span>&#8451;</span>)',
    'INTERNETCON' : 'Internet Connection', 'SWITCHMODE' : 'Switch Mode' ,
    'IP1': 'IP Address', 'IP2': 'IP Address', 'NETMASK1': 'Netmask', 'NETMASK2': 'Netmask',
    'MODE1': 'Mode', 'MODE2': 'Mode', 'MAC1': 'MAC Address', 'MAC2': 'MAC Address',
    'IPUSB2': 'IP Address', 'NETMASKUSB2': 'Netmask', 'MACUSB2': 'MAC Address',
    'MODEUSB2': 'Mode', 'CONNECTUSB': 'USB Connected', 'CONNECTSD': 'SD Connected', 'DUMMYLINE' : 'Dummy'
}

var list = [];
var files = ['dataInfo.json', 'cpu.json', 'networks.json'];
var results = [];
var defaultrouteMode = 0;
var defaultroute1 = '';
var defaultroute2 = '';
var gateway1 = '';
var gateway2 = '';
var switchmode = '';

// get all JSONs
async function fetchMoviesAndCategories() {
    const [cpu, networks, dataInfo] = await Promise.all([
        fetch('cpu.json'),
        fetch('networks.json'),
        fetch('dataInfo.json')
    ]);

    if (!cpu.ok || !networks.ok || !dataInfo.ok) {
        const message = `An error has occured: ${cpu.ok} ${networks.ok} ${dataInfo.ok}`;
        throw new Error(message);
    }

    const cpuJSON = await cpu.json();
    const networksJSON = await networks.json();
    const dataInfoJSON = await dataInfo.json();
    return [cpuJSON, networksJSON, dataInfoJSON];
}

// construct table 
fetchMoviesAndCategories().then(([cpuJSON, networksJSON, dataInfoJSON]) => {
    var table = "<table width='430' summary='Main'>";
    var array = [];
    var tableData = "";
    var tableCPU = "";
    var tableNET = "";

    tableData = JSONInsertTableDATA(tableData, 0, dataInfoJSON, array);
//    tableCPU = JSONInsertTableCPU(tableCPU, 1, cpuJSON, array);
    tableNET = JSONInsertTableNET(tableNET, 2, networksJSON, array);

    table += tableData;

    if(array[4] != []){    
        table += `<tr class="odd">`
        if (array[5]==1){
            table += `<td class="item">${rowTexts[array[4]]}:</td>
            <td><div id="${array[4]}" class ="connected">Connected</div></td>`;
        }
        else {
            table += `<td class="item">${rowTexts[array[4]]}:</td>
            <td><div id="${array[4]}" class ="disconnected">Disconnected</div></td>`;
        }
        table += `</tr>`;
    }

    table += tableCPU;
    table += tableNET;
    if(array[0] != []){
        table += `<tr class="head">
            <td colspan="2">External Devices <img src="info-icon.png" height="12px" style="float: right;"  title="Files into external devices can be accessed by application 
using '$$USB$$/folder/file.txt' and '$$SDcard$$/folder/file.txt'."</td>
            </tr>`;
            table += `<tr class="even">`
            table += `<td class="item">${rowTexts[array[0]]}:</td>
                    <td id="${array[0]}">${array[1]}</td>`;
            table += `</tr>`;
            table += `<tr class="odd">`
            table += `<td class="item">${rowTexts[array[2]]}:</td>
                    <td id="${array[2]}">${array[3]}</td>`;
            table += `</tr>`;

/*
            table += `<td class="item">SD Connected:</td>
                    <td class="item"><div id="${array[0]}" style="display: inline;">${array[1]}</div>
                    <div id="infoSDtext1" class="HideInfoSD"> (</div><div id="SDUSEDPERC" class="HideInfoSD">41</div><div id="infoSDtext2" class="HideInfoSD">%, </div>
                    <div id="SDUSED" class="HideInfoSD">1545</div>
                    <div id="infoSDtext3" class="HideInfoSD"> of </div>
                    <div id="SDTOTAL" class="HideInfoSD"">3765</div>
                    <div id="infoSDtext4" class="HideInfoSD"> GB)</div></td>`;
            table += `</tr>`;
            table += `<tr class="odd">`
            table += `<td class="item">USB Connected:</td>
                    <td class="item"><div id="${array[2]}" style="display: inline;">${array[3]}</div>
                    <div id="infoUSBtext1" class="HideInfoSD"> (</div><div id="USBUSEDPERC" class="HideInfoSD">41</div><div id="infoUSBtext2" class="HideInfoSD">%, </div>
                    <div id="USBUSED" class="HideInfoSD">1545</div>
                    <div id="infoUSBtext3" class="HideInfoSD"> of </div>
                    <div id="USBTOTAL" class="HideInfoSD"">3765</div>
                    <div id="infoUSBtext4" class="HideInfoSD"> GB)</div></td>`;
            table += `</tr>`;
*/
    }

    table += "</table>";
    document.getElementById("TableJSON").innerHTML += table;
}).catch(error => {
    console.log("PLC500 disconnected");
    console.log(error);
});

function JSONInsertTableDATA(table, title, dataJSON, array){
    const json = JSON.stringify(dataJSON);
    const obj = JSON.parse(json);
    var InternalMemory = [];
    var RamMemory = [];

    delete obj['DUMMYLINE'];

    if (title == 0) { // if dataInfo
        array.push('CONNECTSD', obj['CONNECTSD']);
        array.push('CONNECTUSB', obj['CONNECTUSB']);
        delete obj['CONNECTSD'];
        delete obj['CONNECTUSB'];
/*
        delete obj['SDUSEDPERC'];
        delete obj['SDUSED'];
        delete obj['SDTOTAL'];
        delete obj['USBUSEDPERC'];
        delete obj['USBUSED'];
        delete obj['USBTOTAL'];
*/

        InternalMemory.push('FLASHUSEDPERC', obj['FLASHUSEDPERC']);
        InternalMemory.push('FLASHUSED', obj['FLASHUSED']);
        InternalMemory.push('FLASHTOTAL', obj['FLASHTOTAL']);
        delete obj['FLASHUSEDPERC'];
        delete obj['FLASHUSED'];
        delete obj['FLASHTOTAL'];

        
        RamMemory.push('RAMUSEDPERC', obj['RAMUSEDPERC']);
        RamMemory.push('RAMUSED', obj['RAMUSED']);
        RamMemory.push('RAMTOTAL', obj['RAMTOTAL']);
        delete obj['RAMUSEDPERC'];
        delete obj['RAMUSED'];
        delete obj['RAMTOTAL'];

        table += `<tr class="head">
            <td colspan="2">${cellTitles[title]}</td>
            </tr>`;
    }
    values = Object.values(obj);
    for (let key in obj) {
        if (obj[key] != 'not used') {
            let bool = Object.keys(obj).indexOf(key) % 2 ? "odd" : "even";
            table += `<tr class="${bool}">`
            if (rowTexts[key] == 'Codesys Version'){
                table += `<td class="item">${rowTexts[key]}:</td>
                    <td><div style="display: inline;">&ge; </div><div id="${key}" style="display: inline;">${obj[key]}</div></td>`;
            table += `</tr>`;
            }
            else{
            table += `<td class="item">${rowTexts[key]}:</td>
                    <td id="${key}">${obj[key]}</td>`;
            table += `</tr>`;
            }
        }
    };

    if(RamMemory != []){
        table += `<tr class="odd">`
        table += `<td class="item">RAM Memory Usage:</td>
                    <td><div id="${RamMemory[0]}" style="display: inline;">${RamMemory[1]}</div><div style="display: inline;">%   (</div><div id="${RamMemory[2]}" style="display: inline;">${RamMemory[3]}</div><div style="display: inline;"> MB   of </div>
                    <div id="${RamMemory[4]}" style="display: inline;">${RamMemory[5]}</div><div style="display: inline;"> MB)</div></td>`;
        table += `</tr>`;
    }
    
    if(InternalMemory[0] != []){
        table += `<tr class="even">`
        table += `<td class="item">Internal Memory Usage:</td>
                    <td id ="MemoryWarningText"><div id="${InternalMemory[0]}" style="display: inline;">${InternalMemory[1]}</div><div style="display: inline;">%   (</div><div id="${InternalMemory[2]}" style="display: inline;">${InternalMemory[3]}</div><div style="display: inline;"> MB   of </div>
                    <div id="${InternalMemory[4]}" style="display: inline;">${InternalMemory[5]}</div><div style="display: inline;"> MB)</div><img src="alert-icon.png" height="12px" style="float: right;" id="MemoryWarning"; class="WarningMemoryHide";  title="Warning: Internal memory usage has exceeded 90%.
Please clear space to ensure firmware updates 
and optimal performance."></td>`;
        table += `</tr>`;
    }


    return table;
}

function JSONInsertTableCPU(table, title, dataJSON, array){
    const json = JSON.stringify(dataJSON);
    const obj = JSON.parse(json);

    delete obj['DUMMYLINE'];

    if (title == 1) { // if cpu
        table += `<tr class="head">
            <td colspan="2">${cellTitles[title]} <img src="info-icon.png" height="12px" style="float: right;"  title="Temperature > 90 &#8451; the PLC will slow down the processing.
Temperature > 100 &#8451; the PLC will stop."></td>
            </tr>`;
    }
    values = Object.values(obj);

    for (let key in obj) {
        if (obj[key] != 'not used') {
            let bool = Object.keys(obj).indexOf(key) % 2 ? "odd" : "even";
            table += `<tr class="${bool}">`
            table += `<td class="item">${rowTexts[key]}:</td>
                    <td id="${key}">${obj[key]}</td>`;
            table += `</tr>`;
        }
    };
    return table;
}

function JSONInsertTableNET(table, title, dataJSON, array){
    const json = JSON.stringify(dataJSON);
    const obj = JSON.parse(json);

    delete obj['DUMMYLINE'];
    array.push('INTERNETCON', obj['INTERNETCON']);
    delete obj['INTERNETCON'];
    array.push('DEFAULTROUTE', obj['DEFAULTROUTE']);
    delete obj['DEFAULTROUTE'];
    array.push('GATEWAY', obj['GATEWAY']);
    delete obj['GATEWAY'];
    array.push('SWITCHMODE', obj['SWITCHMODE']);
    delete obj['SWITCHMODE'];


    values = Object.values(obj);
    for (let key in obj) {
        if (obj[key] != 'not used') {

            if (title == 2) { // if Networks
                if(key.slice(0,2) == 'IP'){
                    if (key.slice(2,6) === 'USB2') {
                        table += `<tr class="head">
                        <td colspan="2">Ethernet ${key.slice(2)} <img src="info-icon.png" height="12px" style="float: right;"  title="To access the PLC through the USB2, download 
and install the WEG USB/Ethernet Driver,
which is available on the WEG website."></td>
                        </tr>`;
                    }
                    else { 
                        table += `<tr class="head">
                                <td colspan="2"><div style="display: inline;">Ethernet ${key.slice(2)}</div><div id="switchmode${key.slice(2)}" style="display: inline;">${switchmode}</td>
                                </tr>`;
                    }
                }               
            }

            let bool = Object.keys(obj).indexOf(key) % 2 ? "odd" : "even";

            if (key == 'IP1') {
                table += `<tr class="${bool}">`
                table += `<td class="item">${rowTexts[key]}:</td>
                        <td><div id="${key}" style="display: inline;">${obj[key]}</div><div id="DefaultRoute1" style="display: inline;">${defaultroute1}</td>`;
                table += `</tr>`;
            }
            else if (key == 'IP2') {
                table += `<tr class="${bool}">`
                table += `<td class="item">${rowTexts[key]}:</td>
                        <td><div id="${key}" style="display: inline;">${obj[key]}</div><div id="DefaultRoute2" style="display: inline;">${defaultroute2}</td>`;
                table += `</tr>`;
            }
            else if (key == 'MODE1') {
                table += `<tr class="${bool}">`
                table += `<td class="item">${rowTexts[key]}:</td>
                        <td><div id="${key}" style="display: inline;">${obj[key]}</div><div id="Gateway1" style="display: inline;">${gateway1}</td>`;
                table += `</tr>`;
            }
            else if (key == 'MODE2') {
                table += `<tr class="${bool}">`
                table += `<td class="item">${rowTexts[key]}:</td>
                        <td><div id="${key}" style="display: inline;">${obj[key]}</div><div id="Gateway2" style="display: inline;">${gateway2}</td>`;
                table += `</tr>`;
            }
            else {
                table += `<tr class="${bool}">`
                table += `<td class="item">${rowTexts[key]}:</td>
                        <td id="${key}">${obj[key]}</td>`;
                table += `</tr>`;
            }
        }
    };
    return table;
}

function readFile(obj) {
    Object.entries(obj).forEach(([key, value]) => {
        try {
            if (key == 'INTERNETCON'){
                if (value==1){
                    //console.log(`Connected`);
                    document.getElementById(key).innerHTML = 'Connected';
                    document.getElementById(key).classList.remove("disconnected");
                    document.getElementById(key).classList.add("connected");
                }
                else{
                    //console.log(`Disconnected`);
                    document.getElementById(key).innerHTML = 'Disconnected';
                    document.getElementById(key).classList.remove("connected");
                    document.getElementById(key).classList.add("disconnected");
                }
            }
            else if (key == 'DEFAULTROUTE'){
                if (value==1){
                    defaultrouteMode = 1;
                    document.getElementById('DefaultRoute1').innerHTML = '      (Default Route)';
                    document.getElementById('DefaultRoute2').innerHTML = '';
                }
                else if (value==2){
                    defaultrouteMode = 2;
                    document.getElementById('DefaultRoute1').innerHTML = '';
                    document.getElementById('DefaultRoute2').innerHTML = '      (Default Route)';
                }
                else{
                    defaultrouteMode = 0;
                    document.getElementById('DefaultRoute1').innerHTML = '';
                    document.getElementById('DefaultRoute2').innerHTML = '';
                }
            }
            else if (key == 'SWITCHMODE'){
                if (value==1){
                    document.getElementById('switchmode1').innerHTML = '      (Switch Mode)';
                    document.getElementById('switchmode2').innerHTML = '      (Switch Mode)';
                }
                else{
                    document.getElementById('switchmode1').innerHTML = '';
                    document.getElementById('switchmode2').innerHTML = '';
                }
            }
            else if (key == 'GATEWAY'){
                if (defaultrouteMode==1){
                    document.getElementById('Gateway1').innerHTML = '       (Gateway: '+value+')';
                    document.getElementById('Gateway2').innerHTML = '';
                }
                else if (defaultrouteMode==2) {
                    document.getElementById('Gateway1').innerHTML = '';
                    document.getElementById('Gateway2').innerHTML = '       (Gateway: '+value+')';
                }
                else {
                    document.getElementById('Gateway1').innerHTML = '';
                    document.getElementById('Gateway2').innerHTML = '';                   
                }
            }
            else if (key == 'FLASHUSEDPERC'){
                var memoryWarningIco = document.getElementById('MemoryWarning');
                var memoryWarningText = document.getElementById('MemoryWarningText');
                if (value >= 90) {
                    memoryWarningIco.classList.remove("WarningMemoryHide");
                    memoryWarningText.classList.add("WarningMemoryText");
                }  
                else {
                    memoryWarningIco.classList.add("WarningMemoryHide");
                    memoryWarningText.classList.remove("WarningMemoryText");
                }

                document.getElementById('FLASHUSEDPERC').innerHTML = value;
            }
/*            else if (key == 'CONNECTSD'){
                document.getElementById(key).innerHTML = value;
                var memorySDText1 = document.getElementById('infoSDtext1');
                var memorySDText2 = document.getElementById('infoSDtext2');
                var memorySDText3 = document.getElementById('infoSDtext3');
                var memorySDText4 = document.getElementById('infoSDtext4');
                var memorySDTextPerc = document.getElementById('SDUSEDPERC');
                var memorySDTextMB = document.getElementById('SDUSED');
                var memorySDTotalTextMB = document.getElementById('SDTOTAL');
                if (value == 'Yes') {
                    memorySDText1.classList.remove("HideInfoSD");
                    memorySDText2.classList.remove("HideInfoSD");
                    memorySDText3.classList.remove("HideInfoSD");
                    memorySDText4.classList.remove("HideInfoSD");
                    memorySDTextPerc.classList.remove("HideInfoSD");
                    memorySDTextMB.classList.remove("HideInfoSD");
                    memorySDTotalTextMB.classList.remove("HideInfoSD");
            
                    memorySDText1.classList.add("ShowInfoSD");
                    memorySDText2.classList.add("ShowInfoSD");
                    memorySDText3.classList.add("ShowInfoSD");
                    memorySDText4.classList.add("ShowInfoSD");
                    memorySDTextPerc.classList.add("ShowInfoSD");
                    memorySDTextMB.classList.add("ShowInfoSD");
                    memorySDTotalTextMB.classList.add("ShowInfoSD");
                }
                else {
                    memorySDText1.classList.add("HideInfoSD");
                    memorySDText2.classList.add("HideInfoSD");
                    memorySDText3.classList.add("HideInfoSD");
                    memorySDText4.classList.add("HideInfoSD");
                    memorySDTextPerc.classList.add("HideInfoSD");
                    memorySDTextMB.classList.add("HideInfoSD");
                    memorySDTotalTextMB.classList.add("HideInfoSD");
            
                    memorySDText1.classList.remove("ShowInfoSD");
                    memorySDText2.classList.remove("ShowInfoSD");
                    memorySDText3.classList.remove("ShowInfoSD");
                    memorySDText4.classList.remove("ShowInfoSD");
                    memorySDTextPerc.classList.remove("ShowInfoSD");
                    memorySDTextMB.classList.remove("ShowInfoSD");
                    memorySDTotalTextMB.classList.remove("ShowInfoSD");
                }
            }
            else if (key == 'CONNECTUSB'){
                document.getElementById(key).innerHTML = value;
                var memoryUSBText1 = document.getElementById('infoUSBtext1');
                var memoryUSBText2 = document.getElementById('infoUSBtext2');
                var memoryUSBText3 = document.getElementById('infoUSBtext3');
                var memoryUSBText4 = document.getElementById('infoUSBtext4');
                var memoryUSBTextPerc = document.getElementById('USBUSEDPERC');
                var memoryUSBTextMB = document.getElementById('USBUSED');
                var memoryUSBTotalTextMB = document.getElementById('USBTOTAL');
                if (value == 'Yes') {
                    memoryUSBText1.classList.remove("HideInfoSD");
                    memoryUSBText2.classList.remove("HideInfoSD");
                    memoryUSBText3.classList.remove("HideInfoSD");
                    memoryUSBText4.classList.remove("HideInfoSD");
                    memoryUSBTextPerc.classList.remove("HideInfoSD");
                    memoryUSBTextMB.classList.remove("HideInfoSD");
                    memoryUSBTotalTextMB.classList.remove("HideInfoSD");
            
                    memoryUSBText1.classList.add("ShowInfoSD");
                    memoryUSBText2.classList.add("ShowInfoSD");
                    memoryUSBText3.classList.add("ShowInfoSD");
                    memoryUSBText4.classList.add("ShowInfoSD");
                    memoryUSBTextPerc.classList.add("ShowInfoSD");
                    memoryUSBTextMB.classList.add("ShowInfoSD");
                    memoryUSBTotalTextMB.classList.add("ShowInfoSD");
                }
                else {
                    memoryUSBText1.classList.add("HideInfoSD");
                    memoryUSBText2.classList.add("HideInfoSD");
                    memoryUSBText3.classList.add("HideInfoSD");
                    memoryUSBText4.classList.add("HideInfoSD");
                    memoryUSBTextPerc.classList.add("HideInfoSD");
                    memoryUSBTextMB.classList.add("HideInfoSD");
                    memoryUSBTotalTextMB.classList.add("HideInfoSD");
            
                    memoryUSBText1.classList.remove("ShowInfoSD");
                    memoryUSBText2.classList.remove("ShowInfoSD");
                    memoryUSBText3.classList.remove("ShowInfoSD");
                    memoryUSBText4.classList.remove("ShowInfoSD");
                    memoryUSBTextPerc.classList.remove("ShowInfoSD");
                    memoryUSBTextMB.classList.remove("ShowInfoSD");
                    memoryUSBTotalTextMB.classList.remove("ShowInfoSD");
                }
            }
*/
            else
            document.getElementById(key).innerHTML = value;
        }
        catch (e) {
            //console.log(`There is no ${key} ${value}`);
        }
        // console.table(key, value);
    });
};



setInterval(function () {
    files.forEach(function (file, i) {
        list.push(
            fetch(file)
                .then(function (result) {
                    return result.json();
                })
                .then(function (data) {
                    const json = JSON.stringify(data);
                    const obj = JSON.parse(json);
                    readFile(obj);
                })
                .catch(function (err) {
                    console.log("PLC500 disconnected");
                    console.log(err);
                })
        )
    });
    Promise.all(list);
}, 1000);