"""
-> servidores web necessitam de persistencia dos dados, tanto para salvar 
as sessoes quanto para acesso aos usuarios, alem de outros usos
-> base de dados basica para salvar em unidade basica DICT para depois 
trabalhar com JSON e obter novamente os dados necessarios
-> nao utilizar dados em cache (REDIS) para nao utilizar a memoria RAM e 
nem instalar pacotes adicionais no sistema
"""
from webserver.variables import mutex
import shelve
import time
import os


class DataBase(object):
    """
    -> class para ler e escrever as credenciais de acesso na pagina web
    -> aqui o acesso depende do SID no cookie recebido, deve obrigatoriamente 
    possuir para acessar a sessao
    """
    def __init__(self) -> None:
        self.data = None

    def read_data(self, file_path) -> dict:
        # threading pattern
        with mutex:
            with shelve.open(file_path) as db:
                self.data = dict(db)
        return self.data

    def write_data(self, file_path, key, value) -> dict:
        with mutex:
            with shelve.open(file_path) as db:
                db.update({key: value})
                self.data = dict(db)
        # criar delay para mitigar DDoS
        time.sleep(0.5)
        # print(self.data)
        return self.data

    def remove_data(self, file_path, key) -> None:
        session_path = file_path + "_" + key
        # print(session_path)
        with mutex:
            with shelve.open(session_path) as db:
                del db[key]
                self.data = dict(db)
                # print(self.data)
